package com.bpcl.lpg.core.dao.impl;

import de.hybris.platform.servicelayer.search.SearchResult;
import java.util.Collections;
import java.util.Objects;
import java.util.Map;
import de.hybris.platform.servicelayer.search.FlexibleSearchQuery;
import java.util.HashMap;
import java.util.List;
import com.bpcl.lpg.core.enums.GenericStatusEnum;
import java.util.Date;
import com.bpcl.lpg.core.dao.NewConnectionDao;
import com.bpcl.lpg.core.model.NewConnectionsModel;
import de.hybris.platform.servicelayer.internal.dao.DefaultGenericDao;

public class NewConnectionDaoImpl extends DefaultGenericDao<NewConnectionsModel> implements NewConnectionDao
{
    public NewConnectionDaoImpl(final String typecode) {
        super(typecode);
    }
    
    public List<NewConnectionsModel> getNewConnectionsTransaction(final Date startDate, final Date endDate, final GenericStatusEnum newConnectionStatus) {
        final StringBuilder query = new StringBuilder("SELECT {nc.pk} from {").append("NewConnections").append(" as nc JOIN ").append("GenericStatusEnum").append(" as gse on {nc.").append("status").append("}={gse.pk}} WHERE {gse.code}=?").append("status").append(" AND {nc.").append("creationtime").append("}>= ?").append("startTime").append(" AND {nc.").append("creationtime").append("}<= ?").append("endTime");
        final Map<String, Object> param = new HashMap<String, Object>();
        param.put("status", newConnectionStatus.getCode());
        param.put("startTime", startDate);
        param.put("endTime", endDate);
        final FlexibleSearchQuery flexibleSearchQuery = new FlexibleSearchQuery(query);
        flexibleSearchQuery.addQueryParameters((Map)param);
        final SearchResult<NewConnectionsModel> search = (SearchResult<NewConnectionsModel>)this.getFlexibleSearchService().search(flexibleSearchQuery);
        return Objects.isNull(search) ? Collections.emptyList() : search.getResult();
    }
}
